' ================================================================================================
'  Slot Operations example
' ================================================================================================


' ------------------------------------------------------------------------------------------------
' This function is executed 50 times per second (no pauses here or the whole program is locked)
' Funzione eseguita 50 volte al sec. (niente pause qui altrimenti tutto il programma si blocca)
' ------------------------------------------------------------------------------------------------
Sub FastExecution
	Dim n As Single = ReadSlot(1) + ReadSlot(2) + ReadSlot(3)
	n = n / 3                   ' <<<--- da usare se si vuole il risultato tra zero e 1000
	WriteSlot(4, n)
	Label1.text = n.Tostring    ' <<<--- da usare se si vuole stampare il risultato
End Sub


' ------------------------------------------------------------------------------------------------
' This function is executed in a separate Thread - Do here slow and paused operations
' Questa funzione e' eseguita in un thread separato - Far qui le operazioni lente o con pause
' ------------------------------------------------------------------------------------------------ 
Sub PausableExecution()

End Sub


' ================================================================================================
'  - ENG - THE SIMPLIFIED MANAGEMENT ENDS HER - MODIFY THE FOLLOWING CAREFULLY
' ------------------------------------------------------------------------------------------------
'  - ITA - LA GESTIONE SEMPLIFICATA FINISCE QUI - MODIFICARE LA PARTE SEGUENTE CON ATTENZIONE
' ================================================================================================


Sub Main(ByVal s() As String)
	If Form1 IsNot Nothing Then Return
	Form1 = New form
	InitializeComponents
	MemoryMappedFile_Init
	StartThread
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(10)
	End While
End Sub

Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Form1.Closing
	Timer1.Stop
	objThread.Abort
	WriteSlot(1, 0)
End Sub

Sub StartThread()
	' --------------------------------------------------------- asynchronously start the Thread 
	objThread = New Threading.Thread(AddressOf ExecuteThread)
	' --------------------------------------------------------- make the thread as background thread.
	objThread.IsBackground = True
	' --------------------------------------------------------- set the Priority of the thread.
	objThread.Priority = Threading.ThreadPriority.highest
	' --------------------------------------------------------- start the thread.
	objThread.Start()
End Sub

Sub ExecuteThread
	Do
		PausableExecution
		PausaMS(1)
	Loop Until False
End Sub

Sub PausaMS(ByVal mS As Int32)
	Threading.Thread.Sleep(mS)
End Sub

Sub Timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles Timer1.Tick
	FastExecution
End Sub


' ---------------------------------------------------------------------- User Interface Components
WithEvents Form1 As Form
WithEvents Timer1 As Timer = New Timer
Dim objThread As Threading.Thread
Dim Label1 As Label = New Label


Sub InitializeComponents()
	Application.EnableVisualStyles
	form1.SuspendLayout
	' ------------------------------------------------------------------ Form
	Form1.Text = "Theremino Script - Slot4 = Slot1 + Slot2 + Slot3"
	Form1.ClientSize = New System.Drawing.Size(450, 40)
	Form1.MinimumSize = Form1.Size
	Form1.StartPosition = FormStartPosition.CenterScreen
	' ------------------------------------------------------------------ Label 1
	Label1.BorderStyle = BorderStyle.Fixed3D
	Label1.Location = New Point(10, 10)
	Label1.Font = New Font("Arial", 12 )
	Label1.Size = New Size(430, 21)
	Label1.Anchor = AnchorStyles.top Or AnchorStyles.Left Or AnchorStyles.right
	Form1.Controls.Add(Label1)
	' ------------------------------------------------------------------ Timer 1
	Timer1.Interval = 15
	Timer1.Start
	' -------------------------------------------------------------------------------
	' RICHIESTA DI ANDARE IN REAL-TIME
	' -------------------------------------------------------------------------------
	'System.Threading.Thread.CurrentThread.Priority = System.Threading.ThreadPriority.Normal
	'System.Diagnostics.Process.GetCurrentProcess().PriorityClass = ProcessPriorityClass.RealTime
	'' ------------------------------------------------------------------ 
	'SistemaPrecisoAlMillisecondo
	' ------------------------------------------------------------------ 
	Form1.ResumeLayout
	Form1.PerformLayout()
	Form1.show
End Sub


' ===============================================================
'        PRECISIONE TIMERS WINDOWS
' =============================================================== 
<System.Runtime.InteropServices.DllImport("winmm.dll")> _
Private Function timeBeginPeriod(ByVal uPeriod As Int32) As Int32
End Function
<System.Runtime.InteropServices.DllImport("winmm.dll")> _
Private Function timeEndPeriod(ByVal uPeriod As Int32) As Int32
End Function
Private Sub SistemaPrecisoAlMillisecondo()
	timeBeginPeriod(1)
End Sub
Private Sub SistemaNormalePrecisione()
	timeEndPeriod(1)
End Sub

